
%% STS theory : eg1_sts
[sts].
delete_theory_and_dependents(e1_sts).
add_theory(e1_sts).

include_theory(stdops, share).
include_theory(iarith, all).
include_theory(localness, all).
include_theory(sts, all).

declare_object_vars(w).
declare_object_vars(y).
declare_object_vars(z).

declare g.
declare g1.
declare g2.
declare g3.
declare g4.
declare g5.
declare g6.
declare h.
declare h1.
declare h2.
declare h3.
declare h4.
declare k.
declare k1.
declare k2.
declare k3.
declare s1.
declare s10.
declare s11.
declare s12.
declare s13.
declare s14.
declare s2.
declare s3.
declare s4.
declare s5.
declare s6.
declare s7.
declare s8.
declare s9.
axiom is_trans_s1_g === is_trans(state(s1, []), g, A) <=> (A = g1) or (A = g2) or (A = g3) or (A = g4) or (A = g5) or (A = g6).
axiom is_trans_s1_h === is_trans(state(s1, []), h, A) <=> false.
axiom is_trans_s1_k === is_trans(state(s1, []), k, A) <=> false.
axiom is_trans_s10_g === is_trans(state(s10, []), g, A) <=> false.
axiom is_trans_s10_h === is_trans(state(s10, []), h, A) <=> false.
axiom is_trans_s10_k === is_trans(state(s10, []), k, A) <=> false.
axiom is_trans_s11_g === is_trans(state(s11, []), g, A) <=> false.
axiom is_trans_s11_h === is_trans(state(s11, []), h, A) <=> false.
axiom is_trans_s11_k === is_trans(state(s11, []), k, A) <=> false.
axiom is_trans_s12_g === is_trans(state(s12, []), g, A) <=> false.
axiom is_trans_s12_h === is_trans(state(s12, []), h, A) <=> false.
axiom is_trans_s12_k === is_trans(state(s12, []), k, A) <=> false.
axiom is_trans_s13_g === is_trans(state(s13, []), g, A) <=> false.
axiom is_trans_s13_h === is_trans(state(s13, []), h, A) <=> false.
axiom is_trans_s13_k === is_trans(state(s13, []), k, A) <=> false.
axiom is_trans_s14_g === is_trans(state(s14, []), g, A) <=> false.
axiom is_trans_s14_h === is_trans(state(s14, []), h, A) <=> false.
axiom is_trans_s14_k === is_trans(state(s14, []), k, A) <=> false.
axiom is_trans_s2_g === is_trans(state(s2, [A]), g, B) <=> false.
axiom is_trans_s2_h === is_trans(state(s2, [A]), h, B) <=> (B = h1).
axiom is_trans_s2_k === is_trans(state(s2, [A]), k, B) <=> false.
axiom is_trans_s3_g === is_trans(state(s3, [A]), g, B) <=> false.
axiom is_trans_s3_h === is_trans(state(s3, [A]), h, B) <=> false.
axiom is_trans_s3_k === is_trans(state(s3, [A]), k, B) <=> (B = k1).
axiom is_trans_s4_g === is_trans(state(s4, [A]), g, B) <=> false.
axiom is_trans_s4_h === is_trans(state(s4, [A]), h, B) <=> (B = h2).
axiom is_trans_s4_k === is_trans(state(s4, [A]), k, B) <=> (B = k2).
axiom is_trans_s5_g === is_trans(state(s5, [A]), g, B) <=> false.
axiom is_trans_s5_h === is_trans(state(s5, [A]), h, B) <=> (B = h3).
axiom is_trans_s5_k === is_trans(state(s5, [A]), k, B) <=> false.
axiom is_trans_s6_g === is_trans(state(s6, [A]), g, B) <=> false.
axiom is_trans_s6_h === is_trans(state(s6, [A]), h, B) <=> (B = h4).
axiom is_trans_s6_k === is_trans(state(s6, [A]), k, B) <=> false.
axiom is_trans_s7_g === is_trans(state(s7, [A]), g, B) <=> false.
axiom is_trans_s7_h === is_trans(state(s7, [A]), h, B) <=> false.
axiom is_trans_s7_k === is_trans(state(s7, [A]), k, B) <=> (B = k3).
axiom is_trans_s8_g === is_trans(state(s8, []), g, A) <=> false.
axiom is_trans_s8_h === is_trans(state(s8, []), h, A) <=> false.
axiom is_trans_s8_k === is_trans(state(s8, []), k, A) <=> false.
axiom is_trans_s9_g === is_trans(state(s9, []), g, A) <=> false.
axiom is_trans_s9_h === is_trans(state(s9, []), h, A) <=> false.
axiom is_trans_s9_k === is_trans(state(s9, []), k, A) <=> false.
axiom to_g1 === to(g1, state(s1, []), A) = state(s2, [A]).
axiom formula_g1 === formula(g1, state(s1, []), A) = (A < 5).
axiom to_g2 === to(g2, state(s1, []), A) = state(s3, [A]).
axiom formula_g2 === formula(g2, state(s1, []), A) = (A = 4).
axiom to_g3 === to(g3, state(s1, []), A) = state(s4, [A]).
axiom formula_g3 === formula(g3, state(s1, []), A) = (A = 5).
axiom to_g4 === to(g4, state(s1, []), A) = state(s5, [A]).
axiom formula_g4 === formula(g4, state(s1, []), A) = (A = 5).
axiom to_g5 === to(g5, state(s1, []), A) = state(s6, [A]).
axiom formula_g5 === formula(g5, state(s1, []), A) = (A > 5).
axiom to_g6 === to(g6, state(s1, []), A) = state(s7, [A]).
axiom formula_g6 === formula(g6, state(s1, []), A) = (A = 10).
axiom to_h1 === to(h1, state(s2, [A]), nd) = state(s8, []).
axiom formula_h1 === formula(h1, state(s2, [A]), nd) = (true).
axiom to_h2 === to(h2, state(s4, [A]), nd) = state(s10, []).
axiom formula_h2 === formula(h2, state(s4, [A]), nd) = (true).
axiom to_h3 === to(h3, state(s5, [A]), nd) = state(s12, []).
axiom formula_h3 === formula(h3, state(s5, [A]), nd) = (true).
axiom to_h4 === to(h4, state(s6, [A]), nd) = state(s13, []).
axiom formula_h4 === formula(h4, state(s6, [A]), nd) = (true).
axiom to_k1 === to(k1, state(s3, [A]), nd) = state(s9, []).
axiom formula_k1 === formula(k1, state(s3, [A]), nd) = (true).
axiom to_k2 === to(k2, state(s4, [A]), nd) = state(s11, []).
axiom formula_k2 === formula(k2, state(s4, [A]), nd) = (true).
axiom to_k3 === to(k3, state(s7, [A]), nd) = state(s14, []).
axiom formula_k3 === formula(k3, state(s7, [A]), nd) = (true).
axiom is_state_s1 === is_state(state(s1, [])).
axiom is_state_s10 === is_state(state(s10, [])).
axiom is_state_s11 === is_state(state(s11, [])).
axiom is_state_s12 === is_state(state(s12, [])).
axiom is_state_s13 === is_state(state(s13, [])).
axiom is_state_s14 === is_state(state(s14, [])).
axiom is_state_s2 === is_state(state(s2, [A])).
axiom is_state_s3 === is_state(state(s3, [A])).
axiom is_state_s4 === is_state(state(s4, [A])).
axiom is_state_s5 === is_state(state(s5, [A])).
axiom is_state_s6 === is_state(state(s6, [A])).
axiom is_state_s7 === is_state(state(s7, [A])).
axiom is_state_s8 === is_state(state(s8, [])).
axiom is_state_s9 === is_state(state(s9, [])).

close_theory.


save.

theorem thm1 ===
     models(state(s1,[]), dia(g, 4, formula(true))).

theorem thm1a ===
     models(state(s1,[]), ex y:ints dia(g, y, formula(y = 4))).

theorem thm2 ===
     models(state(s1,[]), all y:ints dia(g, y, dia(h, nd, formula(true)))).

theorem thm3 ===
     models(state(s1,[]), ex y:ints box(g, y, dia(h, nd, formula(true)))).

theorem thm4 ===
     models(state(s1,[]), dia(g, 4, formula(true)) or dia(g, 5, formula(true))).

theorem thm5 ===
     models(state(s1,[]), all y:ints box(g, y, dia(h,nd,formula(true)) or dia(k,nd,formula(true)))).

theorem thm6 ===
    models(state(s1,[]), box(k,nd,formula(true))).

theorem thm7 ===
    models(state(s1,[]), ex y:ints box(g, y, box(k, nd, formula(false)))).

%% Not a theorem!!!!!!
theorem thm8 ===
    models(state(s1,[]),all y:ints dia(g,y,dia(k,nd,formula(true)))).


save.
