%% STS theory : b1_sts
[sts].
delete_theory_and_dependents(b1_sts).
add_theory(b1_sts).

include_theory(stdops, share).
include_theory(iarith, all).
include_theory(localness, all).
include_theory(sts, all).

declare_object_vars(w).
declare_object_vars(y).
declare_object_vars(z).

declare in.
declare in1.
declare out.
declare out1.
declare s1.
declare s2.
axiom is_trans_s1_in === is_trans(state(s1, []), in, A) <=> (A = in1).
axiom is_trans_s1_out === is_trans(state(s1, []), out, A) <=> false.
axiom is_trans_s2_in === is_trans(state(s2, [A]), in, B) <=> false.
axiom is_trans_s2_out === is_trans(state(s2, [A]), out, B) <=> (B = out1).
axiom to_in1 === to(in1, state(s1, []), A) = state(s2, [A]).
axiom formula_in1 === formula(in1, state(s1, []), A) = (true).
axiom to_out1 === to(out1, state(s2, [A]), A) = state(s1, []).
axiom formula_out1 === formula(out1, state(s2, [A]), A) = (true).
axiom is_state_s1 === is_state(state(s1, [])).
axiom is_state_s2 === is_state(state(s2, [A])).

close_theory.

theorem thm1 ===
    models(state(s1,[]), all x1:ints box(in, x1, all x2:ints box(out, x2, formula(x1 = x2)))).



save.

